// example of incorporation of C++ into python using boost-python
//

#include <boost/python.hpp>
#include <cmath>


template <typename Container>
void py2stl(const boost::python::list& lst, Container& vec) {
  typedef typename Container::value_type T;
  boost::python::stl_input_iterator<T> beg(lst), end;
  std::for_each(beg, end, [&](const T& t) { vec.push_back(t); });
}


std::string greet(const char * name)
{
  printf("\n%s\n", name);
  std::string a(name);
  return a;
}

int square(int value)
{
  return value*value;
}

double myerf(double value)
{
  return erf(value);
}

double listerf(boost::python::list& ns)
{
  double x=0.0;
  for (int i = 0; i < len(ns); ++i)
    {
        x += erf(boost::python::extract<double>(ns[i]));
    }
  return x;
}

double listerf2(boost::python::list& ns)
{
  double x=0.0;
  std::vector<double>::const_iterator it; 
  std::vector<double>::iterator nit; 
  std::vector<double> newv;
  py2stl(ns, newv);
  for(it=newv.begin(); it < newv.end(); it++) 
    {
       x += erf(*it);
    }
  return x;
}


namespace python = boost::python;

BOOST_PYTHON_MODULE(hello)
{
  python::def("greet",greet);
  python::def("square",square);
  python::def("erf",myerf);
  python::def("listerf",listerf);
  python::def("listerf2",listerf2);
}
