#/usr/bin/env python
# speed comparison for boost::python c++ using a list as argument
# of size n where n is an arguemtn on the commandline (ugly code!)
import hello
import numpy as np
import scipy.special as sp
import time
import sys

print ("------------------------")
print ("Content of the hello C++ module")
print (dir(hello))
print ("------------------------")
a = hello.greet('Peter')

sum = 0.0
if len(sys.argv) > 1:
    n=int(sys.argv[1])
else:
    n=1000
r = np.random.uniform(0,1,n)
rr= r.tolist()
start = time.time()
msum = 0
for ri in rr:
    msum += hello.erf(ri)
end = time.time()
print ("C++ Sum of",n,"ERF(x) values, with random x in 0..1:",msum)
cplustime = end - start
print ("Elapsed:", cplustime)

start = time.time()
msum = hello.listerf2(rr)
end = time.time()
print ("C++ [version2] Sum of",n,"ERF(x) values, with random x in 0..1:",msum)
cplustime = end - start
print ("Elapsed:", cplustime)

msum = 0.0
start = time.time()
x = sp.erf(r)
msum = np.sum(x)
end = time.time()
print ("Python Numpy: Sum of",n,"ERF(x) values, with random x in 0..1:",msum)
nptime = end - start
print ("Elapsed:", nptime)


import math
msum = 0.0
start = time.time()
for i in range(n):
    x = math.erf(r[i])
    #print r,x
    msum += x
end = time.time()
print ("Python Slow: Sum of",n,"ERF(x) values, with random x in 0..1:",msum)
slowtime = end - start
print ("Elapsed:", slowtime)
